<?php
require_once 'system/setup.conf';
require_once 'styles/styles.inc';
require_once 'warp/warplib/applet.inc';
require_once 'warp/warplib/appletutils.inc';

class Warp_Main_Applet extends Warp_Applet
{
var $style;

    function Warp_Main_Applet($caption = "Minerva")
    {
        parent::__construct($caption);
    }

    function init(&$appMan)
    {
       parent::init($appMan);

       $this->style = $appMan->QueryParameter($this, "style");
       $styleCmd = $appMan->QueryParameter($this, "dostyle");
       if ($styleCmd != "") {
          $this->style = $styleCmd;
       }
    }

    function getRefreshParams(&$app_man)
    {
       $ref = $app_man->getArgument($this, "style", $this->style);
       return $ref;
    }

    function getDirectory()
    {
       return "main";
    }

    function renderPanel(&$appMan) 
    {
       $main = "";
       if (class_exists('MasterBar') && $appMan->getMaximisedAppletID() == $this->getID($appMan)) {
          $main .= $appMan->getMasterBarPanel(MasterBar::getPages($appMan));
       }
       return $main;
    }

    function getOutput($cmd) {
       $cmd = "/usr/local/minerva/bin/$cmd";
       $output = array();
        exec("$cmd", $output);
        $line = join($output, "<br>");
        return $line;
    }

    function renderWindow(&$appMan)
    {
         // Top right style control
         $main  = "";
         //$main .= $appmain;
			$main .= "<div align=right>";
         $img = $appMan->getImageReference("style_small", "Handheld tablet");
			$main .= $appMan->getAppletLink($this, "dostyle", STYLE_TABLET_SMALL, $img);

         $img = $appMan->getImageReference("style_large", "Full tablet");
			$main .= $appMan->getAppletLink($this, "dostyle", STYLE_TABLET_LARGE, $img);

         $img = $appMan->getImageReference("style_full", "Full: Desktop");
			$main .= $appMan->getAppletLink($this, "dostyle", STYLE_FULL, $img);
			$main .= "</div>";

         // the home page, where we have only ourselves running
         if ($appMan->getAppletCount() == 1) {
            $info = array();
            $info[] = $this->getOutput("weatherstatus");
            $info[] = "<div align=center><img src=index.png></div>";
            $info[] = $this->getOutput("media default status");
            $info[] = $this->getOutput("hacal life public all 0");
            $info[] = $this->getOutput("hacal culture public all 0");
            $info[] = $this->getOutput("report repeat null calendar 0");

            $main .= "<div align=center>".appletUtils::getGridedContent($info, 3)."</div>";
         }

         // All the applets, drawn as icons
        $idx = 0;
        $links = array();
        foreach($appMan->_applets as $key => $value)
        {
            $app =& $value->getApplet();
            if ($app != $this) {
                $id = $app->getID($appMan);
                $appmain = "<div align=center>";
                $appmain .= $appMan->getLinkBase().$appMan->getMaximiseURL($id);

                $icon = $app->getIconFullURL();
                $icon = "<img src='".$icon."' border=0/>";

                $appmain .= $appMan->getEndLinkBaseText($icon."<br/>".$app->getIconCaption());
                $appmain .= "</div>";
                $links[$idx] = $appmain ;
                ++$idx;
            }
        }

         $main .= "<div align=center>".appletUtils::getGridedContent($links, 3)."</div>";

         if (class_exists('MasterBar')) {
            $main .= "<br/>";
            $main .= $appMan->getMasterBar(MasterBar::getPages($appMan));
         }
         return $main;
    }
}

?>
